
Ruby - Feature #7476

missing "IP_TRANSPARENT" constant for IP sockets.

11/30/2012 03:25 PM - elico (Eliezer Croitoru)

Status: Closed   

Priority: Normal   

Assignee: akr (Akira Tanaka)   

Target version: 2.2.0   

Description

There is a missing constant for IP_TRANSPARENT on linux.

to set the TPROXY on a socket I use:

s.setsockopt(Socket::SOL_IP, 19, 1)

The 19 suppose to be as a constant named: IP_TRANSPARENT or Socket::IP_TRANSPARENT.

Associated revisions

Revision 17a2f1ecc3b3038af71957a6a8f5e02b2b6bf176 - 05/05/2014 03:15 PM - akr (Akira Tanaka)

ext/socket/mkconstants.rb: Add IP_TRANSPARENT.

IP_TRANSPARENT is provieded since glibc-2.12.

Reported by Eliezer Croitoru.  [ruby-core:50372] [Bug #7476]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@45830 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 17a2f1ec - 05/05/2014 03:15 PM - akr (Akira Tanaka)

ext/socket/mkconstants.rb: Add IP_TRANSPARENT.

IP_TRANSPARENT is provieded since glibc-2.12.

Reported by Eliezer Croitoru.  [ruby-core:50372] [Bug #7476]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@45830 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/21/2012 11:03 PM - usa (Usaku NAKAMURA)

- Category set to ext

- Status changed from Open to Assigned

- Assignee set to akr (Akira Tanaka)

- Target version set to 2.0.0

#2 - 02/19/2013 12:37 AM - mame (Yusuke Endoh)

- Tracker changed from Bug to Feature

Looks a feature request.

--

Yusuke Endoh mame@tsg.ne.jp

#3 - 02/24/2013 09:23 PM - ko1 (Koichi Sasada)

- Target version changed from 2.0.0 to 2.1.0

ping -> akr

#4 - 04/02/2013 03:29 PM - akr (Akira Tanaka)

2013/2/24 ko1 (Koichi Sasada) redmine@ruby-lang.org:

Feature #7476: missing "IP_TRANSPARENT" constant for IP sockets.

https://bugs.ruby-lang.org/issues/7476#change-36913

 There is a missing constant for IP_TRANSPARENT on linux.

06/16/2025 1/3

mailto:mame@tsg.ne.jp
mailto:redmine@ruby-lang.org
https://redmine.ruby-lang.org/issues/7476
https://bugs.ruby-lang.org/issues/7476#change-36913


to set the TPROXY on a socket I use:

s.setsockopt(Socket::SOL_IP, 19, 1)

The 19 suppose to be as a constant named: IP_TRANSPARENT or Socket::IP_TRANSPARENT.

 This is Linux-specific and only defined in linux headers

such as /usr/include/linux/in.h.

I'm not sure applications can safely use such headers.

Tanaka Akira

#5 - 04/03/2013 06:23 AM - normalperson (Eric Wong)

Tanaka Akira akr@fsij.org wrote:

2013/2/24 ko1 (Koichi Sasada) redmine@ruby-lang.org:

Feature #7476: missing "IP_TRANSPARENT" constant for IP sockets.

https://bugs.ruby-lang.org/issues/7476#change-36913

 There is a missing constant for IP_TRANSPARENT on linux.

to set the TPROXY on a socket I use:

s.setsockopt(Socket::SOL_IP, 19, 1)

The 19 suppose to be as a constant named: IP_TRANSPARENT or Socket::IP_TRANSPARENT.

 This is Linux-specific and only defined in linux headers

such as /usr/include/linux/in.h.

I'm not sure applications can safely use such headers.

 We already have Linux-specific constants (e.g. TCP_CORK) and

*BSD-specific constants (e.g. TCP_NOPUSH), so I don't think we should

make it hard for users to take advantage of non-portable features on

their favorite OS.

I vote for adding IP_TRANSPARENT (and any other OS-specific constants

users request).

#6 - 04/03/2013 07:23 AM - akr (Akira Tanaka)

2013/4/3 Eric Wong normalperson@yhbt.net:

This is Linux-specific and only defined in linux headers

such as /usr/include/linux/in.h.

I'm not sure applications can safely use such headers.

 We already have Linux-specific constants (e.g. TCP_CORK) and

*BSD-specific constants (e.g. TCP_NOPUSH), so I don't think we should

make it hard for users to take advantage of non-portable features on

their favorite OS.

 

It is not my concern.

TCP_CORK is defined in /usr/include/netinet/tcp.h which is a glibc header.

Tanaka Akira

#7 - 01/30/2014 06:16 AM - hsbt (Hiroshi SHIBATA)

- Target version changed from 2.1.0 to 2.2.0

#8 - 05/05/2014 03:15 PM - akr (Akira Tanaka)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset r45830.
ext/socket/mkconstants.rb: Add IP_TRANSPARENT.

IP_TRANSPARENT is provieded since glibc-2.12.

Reported by Eliezer Croitoru.  [ruby-core:50372] [Bug #7476]

#9 - 05/05/2014 03:17 PM - akr (Akira Tanaka)

It seems glibc-2.12 provides IP_TRANSPARENT.

So there is no problem to use it now.
